// COPYRIGHT 1994 A.D. Software, All rights reserved

// minimal root public layer of OOFILE database
// inline definitions


// -------------------------------------------------------
//                 O O F _ D i c t r e p
// -------------------------------------------------------
inline OOF_bitPointer& OOF_DictRep::item(unsigned int index)
{ 
	return operator[](index); 
}


// -------------------------------------------------------
//               O O F _ D i c t i o n a r y
// -------------------------------------------------------

inline unsigned int OOF_Dictionary::count() const
{
	return mRep->mNextFreeEntry;
}


inline void OOF_Dictionary::start() 
{
	mInternalIter = 0;
}


inline bool OOF_Dictionary::more() 
{
	return mInternalIter < mRep->mNextFreeEntry;
}


inline void OOF_Dictionary::next() 
{
	mInternalIter++;
}


inline bool OOF_Dictionary::EntryMatchesVisibility(const dbClass* entry, bool wantVisible) const 
{
		bool isVisible = !entry->hidden();
		return ((isVisible && wantVisible) || (!isVisible && !wantVisible));
}


inline void OOF_Dictionary::startVisible(bool wantVisible) 
{
	start();
	moreVisible(wantVisible);
}


inline void OOF_Dictionary::nextVisible(bool wantVisible)
{
	next();
	moreVisible(wantVisible);
}
 
 
inline void OOF_Dictionary::append(OOF_bitPointer aBit)  
{
	mRep->Append(aBit);
}


inline void OOF_Dictionary::reset()  
{
	mRep->Reset();
}


 inline OOF_bitPointer& OOF_Dictionary::operator()() // current value
{ 
	return mRep->operator[](mInternalIter); 
}


inline OOF_bitPointer& OOF_Dictionary::operator[](int index)
{
	assert(index>=0);
	return mRep->item(index);
}


inline OOF_bitPointer& OOF_Dictionary::item(unsigned int index)
{ 
	return mRep->item(index); 
}


inline OOF_bitPointer OOF_Dictionary::value(unsigned int index) const
{ 
	return mRep->value(index); 
}