// COPYRIGHT 1995 A.D. Software, All rights reserved

// Private interface of PowerPlant Integration layer of OOFILE database

#ifndef H_OOFPowerPlantX
#define H_OOFPowerPlantX

#include "oofpp.hpp"

class dbCharLink2EditField : public dbFieldLink {
public:
	dbCharLink2EditField(dbChar* fld, LEditField* ctl) :
						mField(fld), 
						mLinkTo(ctl)
						{};
	virtual void copyFieldToLink();
	virtual void copyLinkToField();
	
private:
	LEditField* mLinkTo;
	dbChar* mField;
};


class dbCharLink2TextEdit : public dbFieldLink {
public:
	dbCharLink2TextEdit(dbChar* fld, LTextEdit* ctl) :
						mField(fld), 
						mLinkTo(ctl)
						{};
	virtual void copyFieldToLink();
	virtual void copyLinkToField();

private:
	LTextEdit* mLinkTo;
	dbChar* mField;
};


class dbTextLink2TextEdit : public dbFieldLink {
public:
	dbTextLink2TextEdit(dbText* fld, LTextEdit* ctl) :
						mField(fld), 
						mLinkTo(ctl)
						{};
	virtual void copyFieldToLink();
	virtual void copyLinkToField();

private:
	LTextEdit* mLinkTo;
	dbText* mField;
};


class dbLongLink2EditField : public dbFieldLink {
public:
	dbLongLink2EditField(dbLong* fld, LEditField* ctl) :
						mField(fld), 
						mLinkTo(ctl)
						{};
	virtual void copyFieldToLink();
	virtual void copyLinkToField();
	
private:
	LEditField* mLinkTo;
	dbLong* mField;
};


class dbShortLink2EditField : public dbFieldLink {
public:
	dbShortLink2EditField(dbShort* fld, LEditField* ctl) :
						mField(fld), 
						mLinkTo(ctl)
						{};
	virtual void copyFieldToLink();
	virtual void copyLinkToField();
	
private:
	LEditField* mLinkTo;
	dbShort* mField;
};


class dbDateLink2EditField : public dbFieldLink {
public:
	dbDateLink2EditField(dbDate* fld, LEditField* ctl) :
						mField(fld), 
						mLinkTo(ctl)
						{};
	virtual void copyFieldToLink();
	virtual void copyLinkToField();
	
private:
	LEditField* mLinkTo;
	dbDate* mField;
};


class dbBrowserDisplay { // abstract base to allow us to wrap different controls
public:
	dbBrowserDisplay() {};
	virtual ~dbBrowserDisplay() {};
	virtual void loadData()=0;
	virtual void changeViewTo(dbView*)=0;
	virtual const long selectedRow() const=0;
};


class dbListBoxDisplay : public dbBrowserDisplay {
public:
	dbListBoxDisplay(LListBox* theLB, dbView* theView=0);
	virtual ~dbListBoxDisplay() {};
	virtual void loadData();
	virtual void changeViewTo(dbView*);
	virtual const long selectedRow() const;
private:
	void DeleteAllData();
	void LoadRow(const int row, bool insertTheRow=false);
	void SetColWidths();
	
	LListBox* mDisplay;
	dbView* mView;
	bool mLoadedData;
};

#endif