// CEditArticle.h -- dialog class
// Created 01/01/95 12:01 PM by AppMaker

#pragma once

#include <LDialogBox.h>
#include "oofpp.hpp"

class dbConnect;
class	CdbArticles;

class	LStream;

class	LStdButton;
class	LTextEdit;
class	LListBox;

class CEditArticleFactory : public dbWindowFactory {
public:
CEditArticleFactory(LCommander* C, dbTable* T) : dbWindowFactory(C, T) {};
virtual ~CEditArticleFactory() {};
virtual LWindow* makeWindow(const bool loadData=true) const;
};


//----------
class	CEditArticle :	public LDialogBox, public dbEditHelper {

public:	// these comprise the implementation
	static	CEditArticle*	CreateEditArticleStream	(LStream	*inStream);

						CEditArticle();
						CEditArticle		(LStream	*inStream);
	virtual				~CEditArticle();


		virtual void		DoAddArticleLocation();
		virtual void		DoDelArticleLocation();

	virtual void		ListenToMessage		(MessageT	inMessage,
											 void		*ioParam);

	virtual Boolean		ObeyCommand			(CommandT	inCommand,
											 void		*ioParam = nil);
	virtual void		FindCommandStatus	(CommandT	inCommand,
											 Boolean	&outEnabled,
											 Boolean	&outUsesMark,
											 Char16		&outMark,
											 Str255		outName);
	virtual Boolean		FocusDraw();

protected:
	virtual void		FinishCreateSelf();
void SetDatabase(CdbArticles*); 

protected:
	LStdButton			*mOKButton;
	LStdButton			*mCancelButton;
	LTextEdit			*mTitleField;
	LTextEdit			*mSourceField;
	LTextEdit			*mAuthorsField;
	LTextEdit			*mAbstractField;
	LListBox			*mLocationsList;
	LStdButton			*mAddLocationButton;
	LStdButton			*mDelLocationButton;
	LStdButton			*mGoFirstButton;
	LStdButton			*mGoPrevButton;
	LStdButton			*mGoNextButton;
	LStdButton			*mGoLastButton;

private:
CdbArticles* mArticles;  // our copy to use in Do.. methods

friend LWindow* CEditArticleFactory::makeWindow(const bool) const;
};
