// CListArticles.h -- window class
// Created 01/01/95 12:01 PM by AppMaker

#pragma once

#include <LWindow.h>
#include <LListener.h>
#include "oofpp.hpp"

class dbConnect;
class	CdbArticles;
class	LStream;

class	LListBox;
class	LStdButton;


class CListArticlesFactory : public dbWindowFactory {
public:
CListArticlesFactory(LCommander* C, dbTable* T) : dbWindowFactory(C, T) {};
virtual ~CListArticlesFactory() {};
virtual LWindow* makeWindow(const bool loadData=true) const;
};

//----------
class	CListArticles :	public LWindow, public LListener, public dbBrowseHelper {
public:
	static	CListArticles*	CreateListArticlesStream	(LStream	*inStream);

						CListArticles();
						CListArticles		(LStream	*inStream);
	virtual				~CListArticles();


	virtual void		ListenToMessage		(MessageT	inMessage,
											 void		*ioParam);

	virtual Boolean		ObeyCommand			(CommandT	inCommand,
											 void		*ioParam = nil);
	virtual void		FindCommandStatus	(CommandT	inCommand,
											 Boolean	&outEnabled,
											 Boolean	&outUsesMark,
											 Char16		&outMark,
											 Str255		outName);
	virtual Boolean		FocusDraw();

protected:
	virtual void		FinishCreateSelf();
void SetDatabase(CdbArticles*); 
// Panes in this window:
	LListBox			*mArticlesList;
	LStdButton			*mNewButton;
	LStdButton			*mEditButton;
	LStdButton			*mDeleteButton;

private:
CdbArticles* mArticles;  // our copy to use in Do.. methods

friend LWindow* CListArticlesFactory::makeWindow(const bool) const;
};
