// CMainWindow.h -- window class
// Created 01/01/95 12:01 PM by AppMaker

#pragma once

#include <LWindow.h>
#include <LListener.h>
#include "oofpp.hpp"

#include "LControlEnablingEditField.h"

class dbConnect;
class	CdbPhoneControl;
class	LStream;

class	LListBox;
class	LStdButton;
class	LEditField;
class	LStrTableView;

class dbField;


class CMainWindowFactory : public dbWindowFactory {
public:
CMainWindowFactory(LCommander* C, dbTable* T) : dbWindowFactory(C, T) {};
virtual ~CMainWindowFactory() {};
virtual LWindow* makeWindow(const bool loadData=true) const;
};

//----------
class	CMainWindow :	public LWindow, public LListener, public dbBrowseHelper {
public:
	static	CMainWindow*	CreateMainWindowStream	(LStream	*inStream);

						CMainWindow();
						CMainWindow		(LStream	*inStream);
	virtual				~CMainWindow();


		virtual void		DoFind();
		virtual void		DoByLastName();
		virtual void		DoByFirstName();
		virtual void		DoByExtn();
		virtual void		DoByPager();
		virtual void		DoByDepartment();
		virtual void		DoByTitle();
		virtual void		DoShowAll();

	virtual void		ListenToMessage		(MessageT	inMessage,
											 void		*ioParam);
											 
	virtual Boolean		HandleKeyPress(const EventRecord	&inKeyEvent);
											 

	virtual Boolean		ObeyCommand			(CommandT	inCommand,
											 void		*ioParam = nil);
	virtual void		FindCommandStatus	(CommandT	inCommand,
											 Boolean	&outEnabled,
											 Boolean	&outUsesMark,
											 Char16		&outMark,
											 Str255		outName);
	virtual Boolean		FocusDraw();

protected:
	virtual void		FinishCreateSelf();
void SetDatabase(CdbPhoneControl*); 

private:
	void ChangeSortTo(LStdButton*, dbChar& sortField);
	
// Panes in this window:
	LStrTableView		*mMainList;
	LStdButton			*mFindButton;
	LControlEnablingEditField			*mFindField;
	LStdButton			*mLastNameButton;
	LStdButton			*mFirstNameButton;
	LStdButton			*mExtnButton;
	LStdButton			*mPagerButton;
	LStdButton			*mDepartmentButton;
	LStdButton			*mTitleButton;
	LStdButton			*mShowAllButton;

private:
CdbPhoneControl* mPhoneControl;  // our copy to use in Do.. methods
	LStdButton*			mCurrentSortButton;
	dbChar*				mCurrentSortField;

friend LWindow* CMainWindowFactory::makeWindow(const bool) const;
};
