#include "CPeriodicImport.h"
#include "CPhoneControlDoc.h"
#include "CPhoneControlApp.h"

CPeriodicImport::CPeriodicImport(CPhoneControlDoc* inImporter, unsigned long inStartAt, unsigned long inRepeatInSecs) :
	mImporter(inImporter),
	mNextImport(inStartAt),
	mRepeatInSecs(inRepeatInSecs)
{
	StartRepeating();
}


void CPeriodicImport::SpendTime(const EventRecord &inMacEvent)
{
	unsigned long	timeNow;
	GetDateTime(&timeNow);
	if ((timeNow >= mNextImport) && (timeNow - mNextImport < 600) ){ // within 10 minutes
		mNextImport = timeNow + mRepeatInSecs;  
#ifdef BLIND_OPEN
		mImporter->importFromFile(CPhoneControlApp::sImportFilePath);
#endif
	}
}