// CPhoneControlDoc.h -- document class
// Created 01/01/95 12:01 PM by AppMaker

#pragma once

#include <LSingleDoc.h>
#include "oofpp.hpp"

// Define the creator type and file type for your application:
// NOTE: PhCt has been registered with Apple for this application
#define kSignature		'PhCt'
#define kFileType		'PhCt'

class dbConnect;
class	CdbPhoneControl;
class CPeriodicImport;

class	CMainWindow;

//----------
class	CPhoneControlDoc : public LSingleDoc, public dbDocHelper {
public:
						CPhoneControlDoc	(LCommander	*inSuper);
	virtual				~CPhoneControlDoc();

	virtual void		newFile();
	virtual void		openFile	(FSSpec		*inFileSpec);
	virtual void		DoPrint();

	virtual Boolean		ObeyCommand			(CommandT	inCommand,
											 void		*ioParam = nil);
	virtual void		FindCommandStatus	(CommandT	inCommand,
											 Boolean	&outEnabled,
											 Boolean	&outUsesMark,
											 Char16		&outMark,
											 Str255		outName);
	void						importFromFile(const char* inFname);
	
protected:

private:
	void CompleteOpenFile(FSSpec		*inFileSpec);
	void MakeDatabaseObjects();
	void	DoImport();
	void	DoSaveAsText();

// OOFILE members
dbConnect		*mData;	// owned
CdbPhoneControl	*mPhoneControl;	// owned

// scheduling
CPeriodicImport* mImportTimer;
};
